/**
 * tik-tok - Tik Tok is a Javascript tool to easily create beautiful, mobile-friendly, vertical timelines.
 * @version v0.0.1
 * @link https://github.com/datanews/tik-tok
 * @license MIT
 */
"use strict";!function(t,e){"undefined"!=typeof module&&module.exports&&"function"==typeof require?module.exports=e(require("underscore"),require("moment")):"function"==typeof define&&define.amd?define(["underscore","moment"],e):t.TikTok=e(t._,t.moment)}("undefined"!=typeof window?window:this,function(t,e){if("undefined"==typeof t)throw new Error("Underscore is a necessary dependency of TikTok: http://underscorejs.org/");if("undefined"==typeof e)throw new Error("Moment is a necessary dependency of TikTok: http://momentjs.com/");var i={},s={dateFormat:["MMM DD, YYYY","MM/DD/YYYY","M/D/YYYY","DD MMM YYYY","YYYY-MM-DD","YYYY-MM-DD HH:mm:ss"],dateDisplay:"MMM DD, YYYY",descending:!1,csvDelimiter:",",csvQuote:'"',template:'<div class="tik-tok-container tt-bg-color">  <div class="tt-progress-bar">  <div class="tt-progress"></div>  </div>   <% if (typeof title !== \'undefined\' && title) { %>  <div class="tt-header tt-header-color cf">  <div class="tt-label">Timeline:</div>   <div class="tt-title"><%= title %></div>  </div>  <% } %>   <div class="tt-spine-background">  <div class="tt-spine tt-spine-color"></div>  </div>   <div class="tt-spine-end tt-spine-top tt-header-color">  <div><div class="tt-spine-point tt-spine-color"></div></div>  <div><div class="tt-spine tt-spine-color"></div></div>  </div>   <div class="tt-groups">  <% _.forEach(groups, function(g, gi) { %>  <div class="tt-group">  <div class="tt-group-label-wrapper">  <div class="tt-group-label tt-spine-color">  <%= g.display %>  </div>  </div>   <div class="tt-entries">  <% _.forEach(g.entries, function(e, ei) { %>  <div class="tt-entry" id="<%= tiktok.id %>-<%= e.id %>">  <!-- Need to re-think the link field  <a class="tt-entry-link" href="#<%= tiktok.id %>-<%= e.id %>">link</a>  -->   <div class="tt-entry-date"><%= e.dateFormatted %></div>   <% if (e.title) { %>  <h3 class="tt-entry-title"><%= e.title %></h3>  <% } %>   <div class="tt-entry-content-wrapper cf">  <% if (e.media) { %>  <div class="tt-entry-media-wrapper <% if (e.body) { %>with-body<% } %>">  <div class="tt-entry-media <% if (e.source) { %>with-source<% } %>">  <% if (e.type === \'youtube\') { %>  <iframe class="tt-entry-media-youtube" width="100%" height="350" src="<%= e.media %>" frameborder="0" allowfullscreen></iframe>   <% } else if (e.type === \'soundcloud_large\') { %>  <iframe class="tt-entry-media-soundcloud" width="100%" height="350" scrolling="no" frameborder="no" src="<%= e.media %>"></iframe>   <% } else if (e.type === \'soundcloud\') { %>  <iframe class="tt-entry-media-soundcloud" width="100%" height="166" scrolling="no" frameborder="no" src="<%= e.media %>"></iframe>   <% } else if (e.type === \'embed\') { %>  <iframe class="tt-entry-media-embed" width="100%" height="350" scrolling="no" frameborder="no" src="<%= e.media %>"></iframe>   <% } else { %>  <img class="tt-entry-media-image" src="<%= e.media %>">  <% } %>  </div>   <% if (e.source) { %>  <div class="tt-entry-source">  <%= e.source %>  </div>  <% } %>  </div>  <% } %>   <% if (e.body) { %>  <div class="tt-entry-body-wrapper <% if (e.media) { %>with-media<% } %>">  <div class="tt-entry-body"><%= e.body %></div>  </div>  <% } %>  </div>  </div>  <% }) %>  </div>  </div>  <% }) %>  </div>   <div class="tt-spine-end tt-spine-bottom tt-bg-color">  <div><div class="tt-spine-point tt-spine-color"></div></div>  </div> </div> '},n=function(t){this.update(t)};return t.extend(n.prototype,{validGroupByTypes:["months","years","decade"],viewOffset:40,update:function(e){this.options=this.options||{},this.options=t.extend({},s,this.options,e||{}),this.validate(),this.build(),this.render()},add:function(e,i){var n;if(this.options=this.options||{},this.options=t.extend({},s,this.options,i||{}),t.isString(e)&&(e=this.parseCSV(e,this.options.csvDelimiter,this.options.csvQuote)),e=t.isObject(e)&&!t.isArray(e)?[e]:e,!t.isArray(e)||e.length<=0)throw new Error('"entries" provided could not be made into an array.');this.entries&&this.entries.length>0?(n=t.map(this.entries,t.clone),t.each(e,function(t){n.push(t)})):n=e,this.options.entries=n,this.update()},validate:function(){if(!t.isArray(this.options.entries)&&!t.isString(this.options.entries))throw new Error('"entries" data should be provided as a string or array.');if(this.options.keyMapping&&!t.isObject(this.options.keyMapping))throw new Error('"keyMapping" was not provided as an object.');if(!t.isString(this.options.template)&&!t.isFunction(this.options.template))throw new Error('"template" was not provided as a string or function.');if(!t.isUndefined(this.options.groupBy)&&-1===this.validGroupByTypes.indexOf(this.options.groupBy))throw new Error('"groupBy" was provided but not a valid value.');if(!t.isString(this.options.csvDelimiter)||1!==this.options.csvDelimiter.length)throw new Error('"csvDelimiter" was not provided as a single character string.');if(!t.isString(this.options.csvQuote)||1!==this.options.csvQuote.length)throw new Error('"csvQuote" was not provided as a single character string.');if(t.isString(this.options.template))try{this.options.template=t.template(this.options.template)}catch(e){throw new Error("Error parsing template string with underscore templating: "+e.message)}if(this.options.descending=!!this.options.descending,this.isBrowser=this.checkBrowser(),this.isBrowser&&!this.options.el)throw new Error('"el" needs to br provided as a string or object.')},build:function(){if(this.el=this.getElement(this.options.el),this.isBrowser&&!this.el)throw new Error('Could not find a valid element from the given "el" option.');t.isString(this.options.entries)&&(this.options.entries=this.parseCSV(this.options.entries,this.options.csvDelimiter,this.options.csvQuote)),this.entries=this.mapKeys(this.options.entries,this.options.keyMapping),this.entries=this.parseEntries(this.entries),this.entries=this.sortEntries(this.entries,this.options.descending),this.groups=this.groupEntries(this.entries),this.groups=this.sortGroups(this.groups,this.options.descending),this.isBrowser&&(this.id=this.el.id||this.uniqueId("tik-tok-timeline"),this.el.id=this.id)},render:function(){var e=this;this.isBrowser&&(this.el.innerHTML=this.options.template({_:t,groups:this.groups,title:this.options.title,tiktok:this}),window.location.hash&&0===window.location.hash.indexOf("#"+this.id)&&this.scrollTo(window.location.hash),this.eventSmoothAnchor=this.eventSmoothAnchor||function(t){t.preventDefault();var i=this.getAttribute("href");history.pushState(null,null,i),e.scrollTo(i)},t.each(this.el.querySelectorAll("a.tt-entry-link"),t.bind(function(t){t.removeEventListener("click",this.eventSmoothAnchor),t.addEventListener("click",this.eventSmoothAnchor)},this)),this.determinePlacements(),this.barEl=this.getElement("#"+this.id+" .tt-progress-bar"),this.progressEl=this.getElement("#"+this.id+" .tt-progress"),this.determinePlacementsThrottled=t.throttle(t.bind(function(){this.determinePlacements()},this),200),this.eventUpdateProgress=this.eventUpdateProgress||t.bind(this.updateProgress,this),document.removeEventListener("scroll",this.eventUpdateProgress),document.addEventListener("scroll",this.eventUpdateProgress))},updateProgress:function(){var e=document.body.scrollTop,i=window.innerHeight,s=e+i,n=0,o=this.viewOffset+2;this.determinePlacementsThrottled(),e>=this.top-o&&e<=this.bottom-o?(this.barEl.classList.add("enabled"),t.each(this.entries,t.bind(function(t,i){var s=this.entries[i+1]?this.entries[i+1].top:this.bottom;e>=t.top-o&&s-o>e&&(n=i)},this)),s>=this.documentHeight-5&&(n=this.entries.length-1),this.progressEl.style.width=n/(this.entries.length-1)*100+"%"):this.barEl.classList.remove("enabled")},getElement:function(t){var e;return this.isBrowser&&t?t.nodeType?t:"string"==typeof t&&(e=document.getElementById(t),!e&&document.querySelector&&(e=document.querySelector(t)),e&&e.nodeType)?e:t[0]&&t[0].nodeType?t[0]:null:null},checkBrowser:function(){return!("undefined"==typeof window||!document)},sortGroups:function(e,i){return i=i||!1,e=t.map(e,function(e){return e.entries=t.sortBy(e.entries,function(t){return t.date.unix()*(i?-1:1)}),e}),t.sortBy(e,function(t){return t.date.unix()*(i?-1:1)})},sortEntries:function(e,i){return i=i||!1,t.sortBy(e,function(t){return t.date.unix()*(i?-1:1)})},groupEntries:function(i){var s,n={};return this.groupType=this.options.groupBy&&-1!==this.validGroupByTypes.indexOf(this.options.groupBy)?this.options.groupBy:this.determineGroups(this.entries),s="groupBy"+this.groupType.charAt(0).toUpperCase()+this.groupType.slice(1),s=this[s],t.each(i,t.bind(function(i){var o=t.bind(s,this)(i,e,this.options.groupByDisplay);n[o.id]?n[o.id].entries.push(i):(n[o.id]=o,n[o.id].entries=[i])},this)),t.values(n)},groupByHours:function(t,e,i){return{id:t.date.format("YYYY-MM-DD-HH"),date:e(t.date.format("YYYY-MM-DD-HH"),"YYYY-MM-DD-HH"),display:e(t.date.format("YYYY-MM-DD-HH"),"YYYY-MM-DD-HH").format(i?i:"h a")}},groupByDays:function(t,e,i){return{id:t.date.format("YYYY-MM-DD"),date:e(t.date.format("YYYY-MM-DD"),"YYYY-MM-DD"),display:e(t.date.format("YYYY-MM-DD"),"YYYY-MM-DD").format(i?i:"dddd")}},groupByMonths:function(t,e,i){return{id:t.date.format("YYYY-MM"),date:e(t.date.format("YYYY-MM"),"YYYY-MM"),display:e(t.date.format("YYYY-MM"),"YYYY-MM").format(i?i:"MMM YYYY")}},groupByYears:function(t,e,i){return{id:t.date.format("YYYY"),date:e(t.date.format("YYYY"),"YYYY"),display:e(t.date.format("YYYY"),"YYYY").format(i?i:"YYYY")}},groupByDecades:function(t,e,i){var s=10*Math.floor(t.date.year()/10);return{id:s.toString(),date:e(s.toString(),"YYYY"),display:e(s.toString(),"YYYY").format(i?i:"YYYY['s]")}},determineGroups:function(e){var i=function(t){return t.date.unix()},s=t.min(e,i),n=t.max(e,i),o=n.date.diff(s.date,"years"),r=n.date.diff(s.date,"days");return 1>=r?"hours":7>=r?"days":2>o?"months":20>o?"years":"decades"},parseEntries:function(i){return t.map(i,t.bind(function(t){var i=e(t.date,this.options.dateFormat);return i.isValid()||this.warn('Error parsing date from "'+t.date+'"',t),t.date=i,t.id=this.uniqueId(this.makeIdentifier(t.title)),t.type=t.type||this.determineMediaType(t.media),t.dateFormatted=i.format(this.options.dateDisplay),t},this))},determineMediaType:function(t){return t?-1!==t.indexOf("youtube.com")?"youtube":-1!==t.indexOf("soundcloud.com")&&-1!==t.indexOf("visual=true")?"soundcloud_large":-1!==t.indexOf("soundcloud.com")?"soundcloud":-1!==t.indexOf("embed")||-1!==t.indexOf("iframe")?"embed":"image":void 0},determinePlacements:function(){var e=this,i=document.body,s=document.documentElement;this.top=this.el.getBoundingClientRect().top+window.pageYOffset,this.bottom=this.el.getBoundingClientRect().bottom+window.pageYOffset,this.documentHeight=Math.max(i.scrollHeight,i.offsetHeight,s.clientHeight,s.scrollHeight,s.offsetHeight),this.entries=t.map(this.entries,function(t){return t.el=e.getElement(e.id+"-"+t.id),t.top=t.el.getBoundingClientRect().top+window.pageYOffset,t.bottom=t.el.getBoundingClientRect().bottom+window.pageYOffset,t})},mapKeys:function(e,i){return i=i||{},t.map(e,function(e){var s=t.clone(e);return t.each(i,function(i,n){t.isUndefined(e[i])||i===n||(s[n]=t.clone(e[i]),delete s[i])}),s})},parseCSV:function(e,i,s){i=i||",",s=s||'"';var n=this.regexEscape(i),o=this.regexEscape(s);e=e.replace(/^\s+|\s+$/g,"");for(var r,d=new RegExp("("+n+"|\\r?\\n|\\r|^)(?:"+o+"([^"+o+"]*(?:"+o+o+"[^"+o+"]*)*)"+o+"|([^"+o+n+"\\r\\n]*))","gi"),a=[[]],h=d.exec(e);h;){var l,c=h[1];c.length&&c!==i&&a.push([]),l=h[2]?h[2].replace(new RegExp(""+o+o,"g"),o):h[3],a[a.length-1].push(l.trim()),h=d.exec(e)}if(a.length<=1||!a[0].length)throw new Error("Unable to parse any data from the CSV string provided.");return r=a.shift(),a=t.map(a,function(e){var i={};return t.each(r,function(t,s){i[t]=e[s]}),i})},regexEscape:function(t){return t.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")},makeIdentifier:function(t){return t.toLowerCase().trim().replace(/[^\w ]+/g,"").replace(/ +/g,"-")},scrollTo:function(t,e){e=e||500;var i=this.getElement(t);if(i){var s=document.body,n=s.scrollTop,o=Math.max(0,i.getBoundingClientRect().top+window.pageYOffset-this.viewOffset),r=o-n,d=0,a=40,h=function(){d+=a,s.scrollTop=n+Math.min(1,d/e)*r,e>d&&setTimeout(h,a)};h()}},uniqueId:function(e){return i[e]=t.isUndefined(i[e])?0:i[e]+1,e+"-"+i[e]},warn:function(t){console&&console.warn?console.warn(t):console&&console.log&&console.log(t)}}),n});